Index: src/hu/varadiistvan/scpl/io/Makefile.am
===================================================================
--- src/hu/varadiistvan/scpl/io/Makefile.am	(revision 6)
+++ src/hu/varadiistvan/scpl/io/Makefile.am	(revision 7)
@@ -28,3 +28,4 @@
         Waiter.h                \
         ReadingBuffer.h         \
-        WritingBuffer.h
+        WritingBuffer.h         \
+        WaitableEvent.h
Index: src/hu/varadiistvan/scpl/io/WaitableEvent.h
===================================================================
--- src/hu/varadiistvan/scpl/io/WaitableEvent.h	(revision 7)
+++ src/hu/varadiistvan/scpl/io/WaitableEvent.h	(revision 7)
@@ -0,0 +1,113 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of VSCPL, a simple cross-platform utility library
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef HU_VARADIISTVAN_SCPL_IO_WAITABLEEVENT_H
+#define HU_VARADIISTVAN_SCPL_IO_WAITABLEEVENT_H
+//------------------------------------------------------------------------------
+
+#if 0 // The public interface of WaitableEvent
+
+//------------------------------------------------------------------------------
+
+namespace hu { namespace varadiistvan { namespace scpl { namespace io {
+
+//------------------------------------------------------------------------------
+
+/**
+ * An event on which one can wait with a waiter.
+ */
+class WaitableEvent : public Failable
+{
+public:
+    /**
+     * Construct the event.
+     *
+     * @param waiter the waiter to be used for waiting. If given, the
+     * check() function will always return immediately. If not given,
+     * the check() function may block and returns only when the event
+     * is fired.
+     */
+    WaitableEvent(Waiter* waiter = 0);
+
+    /**
+     * Destroy the event.
+     */
+    virtual ~WaitableEvent();
+
+    /**
+     * Fire the event.
+     */
+    void fire();
+
+    /**
+     * Check if the event is fired or not. If so, the fired status
+     * will be cleared.
+     */
+    bool check();
+};
+
+//------------------------------------------------------------------------------
+
+} /* namespace hu::varadiistvan::scpl::io */ } /* namespace hu::varadiistvan::scpl */ } /* namespace hu::varadiistvan */ } /* namespace hu */
+
+//------------------------------------------------------------------------------
+
+#endif // 0, The public interface of WaitableEvent
+
+//------------------------------------------------------------------------------
+
+#include "hu/varadiistvan/scpl/config.h"
+
+//------------------------------------------------------------------------------
+
+#if TARGET_API_POSIX
+
+#include "_posix/WaitableEvent.h"
+
+//------------------------------------------------------------------------------
+
+#elif TARGET_API_WIN32 || TARGET_API_WIN64
+
+#include "_win32/WaitableEvent.h"
+
+//------------------------------------------------------------------------------
+
+#else
+
+#error "Not implemented for this target!"
+
+#endif
+
+//------------------------------------------------------------------------------
+#endif // HU_VARADIISTVAN_SCPL_WAITABLEEVENT_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/hu/varadiistvan/scpl/io/_posix/Makefile.am
===================================================================
--- src/hu/varadiistvan/scpl/io/_posix/Makefile.am	(revision 6)
+++ src/hu/varadiistvan/scpl/io/_posix/Makefile.am	(revision 7)
@@ -10,5 +10,6 @@
         BufferedStream.cc       \
         ReadingBuffer.cc        \
-        WritingBuffer.cc
+        WritingBuffer.cc        \
+        WaitableEvent.cc
 
 include_vscpl_io_posixdir=$(includedir)/hu/varadiistvan/scpl/io/_posix
@@ -19,3 +20,4 @@
         StreamBuffer.h          \
         ReadingBuffer.h         \
-        WritingBuffer.h
+        WritingBuffer.h         \
+        WaitableEvent.h
Index: src/hu/varadiistvan/scpl/io/_posix/WaitableEvent.cc
===================================================================
--- src/hu/varadiistvan/scpl/io/_posix/WaitableEvent.cc	(revision 7)
+++ src/hu/varadiistvan/scpl/io/_posix/WaitableEvent.cc	(revision 7)
@@ -0,0 +1,126 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of VSCPL, a simple cross-platform utility library
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "WaitableEvent.h"
+
+#include <poll.h>
+#include <unistd.h>
+
+#include <sys/eventfd.h>
+
+//------------------------------------------------------------------------------
+
+using hu::varadiistvan::scpl::io::WaitableEvent;
+
+//------------------------------------------------------------------------------
+
+WaitableEvent::WaitableEvent(Waiter* waiter) :
+    Waitable(waiter, eventfd(0, (waiter==0) ? 0 : EFD_NONBLOCK), POLLIN),
+    fired(false)
+{
+    if (fd<0) {
+        setErrorCodeFromErrno();
+    }
+}
+
+//------------------------------------------------------------------------------
+
+WaitableEvent::~WaitableEvent()
+{
+    close(fd);
+}
+
+//------------------------------------------------------------------------------
+
+void WaitableEvent::fire()
+{
+    static const uint64_t one = 1;
+    if (write(fd, &one, sizeof(one))<0) {
+        if (errno!=EAGAIN) {
+            setErrorCodeFromErrno();
+        }
+    }
+}
+
+//------------------------------------------------------------------------------
+
+bool WaitableEvent::check()
+{
+    if (doCheck()) {
+        fired = false;
+        return true;
+    } else {
+        return false;
+    }
+}
+
+//------------------------------------------------------------------------------
+
+bool WaitableEvent::isReady()
+{
+    return fired;
+}
+
+//------------------------------------------------------------------------------
+
+void WaitableEvent::handleEvents(short events)
+{
+    if ((events&POLLIN)==POLLIN) {
+        doCheck();
+    }
+}
+
+//------------------------------------------------------------------------------
+
+bool WaitableEvent::doCheck(bool fromHandleEvents)
+{
+    if (failed()) return false;
+    if (!fromHandleEvents && fired) return true;
+
+    uint64_t value = 0;
+    if (read(fd, &value, sizeof(value))<0) {
+        if (errno!=EAGAIN) {
+            setErrorCodeFromErrno();
+        }
+    } else {
+        fired = fired || value>0;
+    }
+
+    return fired;
+}
+
+//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/hu/varadiistvan/scpl/io/_posix/WaitableEvent.h
===================================================================
--- src/hu/varadiistvan/scpl/io/_posix/WaitableEvent.h	(revision 7)
+++ src/hu/varadiistvan/scpl/io/_posix/WaitableEvent.h	(revision 7)
@@ -0,0 +1,107 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of VSCPL, a simple cross-platform utility library
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef HU_VARADIISTVAN_SCPL_IO_POSIX_WAITABLEEVENT_H
+#define HU_VARADIISTVAN_SCPL_IO_POSIX_WAITABLEEVENT_H
+//------------------------------------------------------------------------------
+
+#include "Waitable.h"
+
+#include "../Failable.h"
+
+//------------------------------------------------------------------------------
+
+namespace hu { namespace varadiistvan { namespace scpl { namespace io {
+
+//------------------------------------------------------------------------------
+
+/**
+ * An event on which one can wait with a waiter.
+ */
+class WaitableEvent : public Waitable
+{
+private:
+    /**
+     * Indicate if the event is fired.
+     */
+    volatile bool fired;
+
+public:
+    /**
+     * Construct the event.
+     */
+    WaitableEvent(Waiter* waiter = 0);
+
+    /**
+     * Destroy the event.
+     */
+    virtual ~WaitableEvent();
+
+    /**
+     * Fire the event.
+     */
+    void fire();
+
+    /**
+     * Check if the event is fired or not. If so, the fired status
+     * will be cleared.
+     */
+    bool check();
+
+protected:
+    /**
+     * Check if the event is fired or not.
+     */
+    virtual bool isReady();
+
+    /**
+     * Handle the given events.
+     */
+    virtual void handleEvents(short events);
+
+private:
+    /**
+     * Perform the real check. If we already know that we are fired,
+     * just return true. Otherwise try to read from the event fd.
+     */
+    bool doCheck(bool fromHandleEvents = false);
+};
+
+
+//------------------------------------------------------------------------------
+
+} /* namespace hu::varadiistvan::scpl::io */ } /* namespace hu::varadiistvan::scpl */ } /* namespace hu::varadiistvan */ } /* namespace hu */
+
+//------------------------------------------------------------------------------
+#endif // HU_VARADIISTVAN_SCPL_IO_POSIX_WAITABLEEVENT_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/hu/varadiistvan/scpl/io/_win32/Makefile.am
===================================================================
--- src/hu/varadiistvan/scpl/io/_win32/Makefile.am	(revision 6)
+++ src/hu/varadiistvan/scpl/io/_win32/Makefile.am	(revision 7)
@@ -13,3 +13,4 @@
         EventFailable.h         \
         Event.h                 \
-        Waiter.h
+        Waiter.h                \
+        WaitableEvent.h
Index: src/hu/varadiistvan/scpl/io/_win32/WaitableEvent.h
===================================================================
--- src/hu/varadiistvan/scpl/io/_win32/WaitableEvent.h	(revision 7)
+++ src/hu/varadiistvan/scpl/io/_win32/WaitableEvent.h	(revision 7)
@@ -0,0 +1,91 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of VSCPL, a simple cross-platform utility library
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef HU_VARADIISTVAN_SCPL_IO_WIN32_WAITABLEEVENT_H
+#define HU_VARADIISTVAN_SCPL_IO_WIN32_WAITABLEEVENT_H
+//------------------------------------------------------------------------------
+
+#include "Event.h"
+#include "EventFailable.h"
+
+//------------------------------------------------------------------------------
+
+namespace hu { namespace varadiistvan { namespace scpl { namespace io {
+
+/**
+ * An event which can be waited for.
+ */
+class WaitableEvent : public Event, public EventFailable
+{
+public:
+    /**
+     * Construct the event.
+     */
+    WaitableEvent(Waiter* waiter = 0);
+
+    /**
+     * Check if the event is fired or not. If so, the fired status
+     * will be cleared.
+     */
+    bool check();
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline WaitableEvent::WaitableEvent(Waiter* waiter) :
+    Event(static_cast<EventFailable&>(*this))
+{
+    if (waiter!=0) addTo(*waiter);
+}
+
+//------------------------------------------------------------------------------
+
+inline bool WaitableEvent::check()
+{
+    if (isFired()) {
+        clear();
+        return true;
+    } else {
+        return false;
+    }
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace hu::varadiistvan::scpl::io */ } /* namespace hu::varadiistvan::scpl */ } /* namespace hu::varadiistvan */ } /* namespace hu */
+
+//------------------------------------------------------------------------------
+#endif // HU_VARADIISTVAN_SCPL_IO_WIN32_WAITABLEEVENT_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
